<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_FareGroupService ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_FareGroupService extends AbstractStructArrayBase
{
    /**
     * The FareGroupService
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_FareGroupService[]
     */
    public $FareGroupService;
    /**
     * Constructor method for ArrayOfJP_FareGroupService
     * @uses ArrayOfJP_FareGroupService::setFareGroupService()
     * @param \StructType\JP_FareGroupService[] $fareGroupService
     */
    public function __construct(array $fareGroupService = array())
    {
        $this
            ->setFareGroupService($fareGroupService);
    }
    /**
     * Get FareGroupService value
     * @return \StructType\JP_FareGroupService[]|null
     */
    public function getFareGroupService()
    {
        return $this->FareGroupService;
    }
    /**
     * This method is responsible for validating the values passed to the setFareGroupService method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFareGroupService method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFareGroupServiceForArrayConstraintsFromSetFareGroupService(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_FareGroupServiceFareGroupServiceItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_FareGroupServiceFareGroupServiceItem instanceof \StructType\JP_FareGroupService) {
                $invalidValues[] = is_object($arrayOfJP_FareGroupServiceFareGroupServiceItem) ? get_class($arrayOfJP_FareGroupServiceFareGroupServiceItem) : sprintf('%s(%s)', gettype($arrayOfJP_FareGroupServiceFareGroupServiceItem), var_export($arrayOfJP_FareGroupServiceFareGroupServiceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FareGroupService property can only contain items of type \StructType\JP_FareGroupService, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FareGroupService value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FareGroupService[] $fareGroupService
     * @return \ArrayType\ArrayOfJP_FareGroupService
     */
    public function setFareGroupService(array $fareGroupService = array())
    {
        // validation for constraint: array
        if ('' !== ($fareGroupServiceArrayErrorMessage = self::validateFareGroupServiceForArrayConstraintsFromSetFareGroupService($fareGroupService))) {
            throw new \InvalidArgumentException($fareGroupServiceArrayErrorMessage, __LINE__);
        }
        $this->FareGroupService = $fareGroupService;
        return $this;
    }
    /**
     * Add item to FareGroupService value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FareGroupService $item
     * @return \ArrayType\ArrayOfJP_FareGroupService
     */
    public function addToFareGroupService(\StructType\JP_FareGroupService $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_FareGroupService) {
            throw new \InvalidArgumentException(sprintf('The FareGroupService property can only contain items of type \StructType\JP_FareGroupService, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FareGroupService[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_FareGroupService|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_FareGroupService|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_FareGroupService|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_FareGroupService|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_FareGroupService|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FareGroupService
     */
    public function getAttributeName()
    {
        return 'FareGroupService';
    }
}
